//+------------------------------------------------------------------+
//|                                      BetterVolume 1.5 Alerts.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
// Alert code added by Andriy Moraru (http://www.earnforex.com)
// + Alerts can be now turned off for particular colors (2012-08-23)

#property copyright ""
#property link      ""

// BetterVolume 1.5.mq4 
// modified to correct start loop 

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Red 
#property indicator_color2 DeepSkyBlue 
#property indicator_color3 Yellow 
#property indicator_color4 Lime 
#property indicator_color5 White 
#property indicator_color6 Magenta 	// Climax Churn 
#property indicator_color7 LightSeaGreen 	// Ma 		Maroon 

#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4
#property indicator_width4 4
#property indicator_width5 4
#property indicator_width6 4

extern string TimeFrame  = "Current time frame";
extern int     NumberOfBars = 0 ; // 1500 ; 500;
extern string  Note = "0 means Display all bars";
extern int     MAPeriod = 14 ;
extern int     LookBack = 20;
extern int     width1 = 4 ;
extern int     width2 = 4 ;

extern bool UseVisualAlert = false;
extern bool UseSoundAlert = false;
extern bool UseEmailAlert = false;

extern bool IgnoreLightSeaGreen = false;
extern bool IgnoreWhite = false;
extern bool IgnoreFireBrick = false;
extern bool IgnoreDodgerBlue = false;
extern bool IgnoreLightSalmon = false;
extern bool IgnoreMagenta = false;

double red[],blue[],yellow[],green[],white[],magenta[],v4[];

// Variables for alerts:
color CurrentColor[3] = {White, White, White};
datetime LastAlertTime = D'1980.01.01';
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
      SetIndexBuffer(0,red);
      SetIndexStyle(0,DRAW_HISTOGRAM,0,width2);
      SetIndexLabel(0,"Climax High ");
      
      SetIndexBuffer(1,blue);
      SetIndexStyle(1,DRAW_HISTOGRAM,0,width1);
      SetIndexLabel(1,"Neutral");
      
      SetIndexBuffer(2,yellow);
      SetIndexStyle(2,DRAW_HISTOGRAM,0,width1);
      SetIndexLabel(2,"Low ");
      
      SetIndexBuffer(3,green);
      SetIndexStyle(3,DRAW_HISTOGRAM,0,width1);
      SetIndexLabel(3,"HighChurn ");

      SetIndexBuffer(4,white);
      SetIndexStyle(4,DRAW_HISTOGRAM,0,width2);
      SetIndexLabel(4,"Climax Low ");

      SetIndexBuffer(5,magenta);
      SetIndexStyle(5,DRAW_HISTOGRAM,0,width1);
      SetIndexLabel(5,"ClimaxChurn ");

      SetIndexBuffer(6,v4);
      SetIndexStyle(6,DRAW_LINE,0,1);
      SetIndexLabel(6,"Average("+MAPeriod+")");

         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      IndicatorShortName(timeFrameToString(timeFrame)+" Better Volume 1.5" );

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   double VolLowest,Range,Value2,Value3,HiValue2,HiValue3,LoValue3,tempv2,tempv3,tempv;
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

/*
   if ( NumberOfBars == 0 )  //				0 = all - appalling resource hog if using anything but 0 
      NumberOfBars = Bars-counted_bars;
   limit=NumberOfBars; //Bars-counted_bars;
*/
   if ( NumberOfBars == 0 )
      limit = Bars-counted_bars;
   if ( NumberOfBars > 0 && NumberOfBars < Bars )  //
      limit = NumberOfBars - counted_bars;
            if (returnBars) { red[0] = limit+1; return(0); }

   if (timeFrame != Period())
   {
      limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (int i=limit;i>=0;i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            red[i]     = iCustom(NULL,timeFrame,indicatorFileName,"",NumberOfBars,"",MAPeriod,LookBack,width1,width2,UseVisualAlert,UseSoundAlert,UseEmailAlert,IgnoreLightSeaGreen,IgnoreWhite,IgnoreFireBrick,IgnoreDodgerBlue,IgnoreLightSalmon,IgnoreMagenta,0,y);
            blue[i]    = iCustom(NULL,timeFrame,indicatorFileName,"",NumberOfBars,"",MAPeriod,LookBack,width1,width2,UseVisualAlert,UseSoundAlert,UseEmailAlert,IgnoreLightSeaGreen,IgnoreWhite,IgnoreFireBrick,IgnoreDodgerBlue,IgnoreLightSalmon,IgnoreMagenta,1,y);
            yellow[i]  = iCustom(NULL,timeFrame,indicatorFileName,"",NumberOfBars,"",MAPeriod,LookBack,width1,width2,UseVisualAlert,UseSoundAlert,UseEmailAlert,IgnoreLightSeaGreen,IgnoreWhite,IgnoreFireBrick,IgnoreDodgerBlue,IgnoreLightSalmon,IgnoreMagenta,2,y);
            green[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",NumberOfBars,"",MAPeriod,LookBack,width1,width2,UseVisualAlert,UseSoundAlert,UseEmailAlert,IgnoreLightSeaGreen,IgnoreWhite,IgnoreFireBrick,IgnoreDodgerBlue,IgnoreLightSalmon,IgnoreMagenta,3,y);
            white[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",NumberOfBars,"",MAPeriod,LookBack,width1,width2,UseVisualAlert,UseSoundAlert,UseEmailAlert,IgnoreLightSeaGreen,IgnoreWhite,IgnoreFireBrick,IgnoreDodgerBlue,IgnoreLightSalmon,IgnoreMagenta,4,y);
            magenta[i] = iCustom(NULL,timeFrame,indicatorFileName,"",NumberOfBars,"",MAPeriod,LookBack,width1,width2,UseVisualAlert,UseSoundAlert,UseEmailAlert,IgnoreLightSeaGreen,IgnoreWhite,IgnoreFireBrick,IgnoreDodgerBlue,IgnoreLightSalmon,IgnoreMagenta,5,y);
            v4[i]      = iCustom(NULL,timeFrame,indicatorFileName,"",NumberOfBars,"",MAPeriod,LookBack,width1,width2,UseVisualAlert,UseSoundAlert,UseEmailAlert,IgnoreLightSeaGreen,IgnoreWhite,IgnoreFireBrick,IgnoreDodgerBlue,IgnoreLightSalmon,IgnoreMagenta,6,y);
         }
      return(0);
   }      

   //
   //
   //
   //
   //
   
   for(i=0; i<limit; i++)   
      {
         red[i] = 0; blue[i] = Volume[i]; yellow[i] = 0; green[i] = 0; white[i] = 0; magenta[i] = 0;
         Value2=0;Value3=0;HiValue2=0;HiValue3=0;LoValue3=99999999;tempv2=0;tempv3=0;tempv=0;
         if (i <= 2) CurrentColor[i] = White;


         VolLowest = Volume[iLowest(NULL,0,MODE_VOLUME,20,i)];
         if (Volume[i] == VolLowest)
            {
               yellow[i] = NormalizeDouble(Volume[i],0);
               blue[i]=0;
               if (i <= 2) CurrentColor[i] = FireBrick;
            }

         Range = (High[i]-Low[i]);
         Value2 = Volume[i]*Range;

         if (  Range != 0 )
            Value3 = Volume[i]/Range;

         for ( int n=i;n<i+MAPeriod;n++ )
            {
               tempv= Volume[n] + tempv; 
            } 
          v4[i] = NormalizeDouble(tempv/MAPeriod,0);

          for ( n=i;n<i+LookBack;n++)
            {
               tempv2 = Volume[n]*((High[n]-Low[n])); 
               if ( tempv2 >= HiValue2 )
                  HiValue2 = tempv2;

               if ( Volume[n]*((High[n]-Low[n])) != 0 )
                  {           
                     tempv3 = Volume[n] / ((High[n]-Low[n]));
                     if ( tempv3 > HiValue3 ) 
                        HiValue3 = tempv3; 
                     if ( tempv3 < LoValue3 )
                        LoValue3 = tempv3;
                  } 
            }

          if ( Value2 == HiValue2  && Close[i] > (High[i] + Low[i]) / 2 )
            {
               red[i] = NormalizeDouble(Volume[i],0);
               blue[i]=0;
               yellow[i]=0;
               if (i <= 2) CurrentColor[i] = LightSeaGreen;
            }   

          if ( Value3 == HiValue3 )
            {
               green[i] = NormalizeDouble(Volume[i],0);                
               blue[i] =0;
               yellow[i]=0;
               red[i]=0;
               if (i <= 2) CurrentColor[i] = DodgerBlue;
            }
          if ( Value2 == HiValue2 && Value3 == HiValue3 )
            {
               magenta[i] = NormalizeDouble(Volume[i],0);
               blue[i]=0;
               red[i]=0;
               green[i]=0;
               yellow[i]=0;
               if (i <= 2) CurrentColor[i] = Magenta;
            } 
         if ( Value2 == HiValue2  && Close[i] <= (High[i] + Low[i]) / 2 )
            {
               white[i] = NormalizeDouble(Volume[i],0);
               magenta[i]=0;
               blue[i]=0;
               red[i]=0;
               green[i]=0;
               yellow[i]=0;
               if (i <= 2) CurrentColor[i] = LightSalmon;
            }
      }
//----

//----
   if ((CurrentColor[1] != CurrentColor[2]) && (LastAlertTime != Time[1]))
   {
      if ((CurrentColor[1] == LightSeaGreen) && (IgnoreLightSeaGreen)) return(0);
      if ((CurrentColor[1] == White) && (IgnoreWhite)) return(0);
      if ((CurrentColor[1] == FireBrick) && (IgnoreFireBrick)) return(0);
      if ((CurrentColor[1] == DodgerBlue) && (IgnoreDodgerBlue)) return(0);
      if ((CurrentColor[1] == LightSalmon) && (IgnoreLightSalmon)) return(0);
      if ((CurrentColor[1] == Magenta) && (IgnoreMagenta)) return(0);
      
      if (UseVisualAlert) Alert("BetterVolume - Color changed from ", lColorToString(CurrentColor[2]), " to ", lColorToString(CurrentColor[1]), ".");
      if (UseSoundAlert) PlaySound("alert.wav");
      if (UseEmailAlert) SendMail("Better Volume Alert - " + lColorToString(CurrentColor[2]) + " -> " + lColorToString(CurrentColor[1]), Time[1] + " BetterVolume - Color changed from " + lColorToString(CurrentColor[2]) + " to " + lColorToString(CurrentColor[1]) + ".");
      LastAlertTime = Time[1];
   }
   return(0);
  }
  
string lColorToString(color Color)
{
   switch(Color)
   {
      case LightSeaGreen: return("LightSeaGreen");
      case White: return("White");
      case FireBrick: return("FireBrick");
      case DodgerBlue: return("DodgerBlue");
      case LightSalmon: return("LightSalmon");
      case Magenta: return("Magenta");
      default: return("Unknown");
   }
}
//+------------------------------------------------------------------+

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}